Loading...
Searching...
No Matches
juce::PropertySet Class Reference

## Detailed Description

A set of named property values, which can be strings, integers, floating point, etc.

Effectively, this just wraps a StringPairArray in an interface that makes it easier to load and save types other than strings.

See the PropertiesFile class for a subclass of this, which automatically broadcasts change messages and saves/loads the list from a file.

The documentation for this class was generated from the following file:

- juce_core/containers/juce_PropertySet.h

Inheritance diagram for juce::PropertySet:

## Public Member Functions

| PropertySet (bool ignoreCaseOfKeyNames=false)
| Creates an empty PropertySet.
| PropertySet (const PropertySet &other)
| Creates a copy of another PropertySet.
PropertySet & | operator= (const PropertySet &other)
| Copies another PropertySet over this one.
virtual | ~PropertySet ()
| Destructor.
String | getValue (StringRef keyName, const String &defaultReturnValue=String()) const noexcept
| Returns one of the properties as a string.
int | getIntValue (StringRef keyName, int defaultReturnValue=0) const noexcept
| Returns one of the properties as an integer.
double | getDoubleValue (StringRef keyName, double defaultReturnValue=0.0) const noexcept
| Returns one of the properties as an double.
bool | getBoolValue (StringRef keyName, bool defaultReturnValue=false) const noexcept
| Returns one of the properties as an boolean.
std::unique_ptr< XmlElement > | getXmlValue (StringRef keyName) const
| Returns one of the properties as an XML element.
void | setValue (StringRef keyName, const var &value)
| Sets a named property.
void | setValue (StringRef keyName, const XmlElement *xml)
| Sets a named property to an XML element.
void | addAllPropertiesFrom (const PropertySet &source)
| This copies all the values from a source PropertySet to this one.
void | removeValue (StringRef keyName)
| Deletes a property.
bool | containsKey (StringRef keyName) const noexcept
| Returns true if the properties include the given key.
void | clear ()
| Removes all values.
StringPairArray & | getAllProperties () noexcept
| Returns the keys/value pair array containing all the properties.
const CriticalSection & | getLock () const noexcept
| Returns the lock used when reading or writing to this set.
std::unique_ptr< XmlElement > | createXml (const String &nodeName) const
| Returns an XML element which encapsulates all the items in this property set.
void | restoreFromXml (const XmlElement &xml)
| Reloads a set of properties that were previously stored as XML.
void | setFallbackPropertySet (PropertySet *fallbackProperties) noexcept
| Sets up a second PropertySet that will be used to look up any values that aren't set in this one.
PropertySet * | getFallbackPropertySet () const noexcept
| Returns the fallback property set.

## Protected Member Functions

virtual void | propertyChanged ()
| Subclasses can override this to be told when one of the properties has been changed.

## Constructors and Destructors

## PropertySet() [1/2]

juce::PropertySet::PropertySet | ( | bool | ignoreCaseOfKeyNames = false | ) |

Creates an empty PropertySet.

Parameters

  ignoreCaseOfKeyNames | if true, the names of properties are compared in a case-insensitive way

Referenced by addAllPropertiesFrom(), getFallbackPropertySet(), operator=(), propertyChanged(), PropertySet(), and setFallbackPropertySet().

## PropertySet() [2/2]

juce::PropertySet::PropertySet | ( | const PropertySet & | other | ) |

Creates a copy of another PropertySet.

References PropertySet().

## ~PropertySet()

virtual juce::PropertySet::~PropertySet | ( |  | ) |

virtual

Destructor.

## Member Functions

## operator=()

PropertySet & juce::PropertySet::operator= | ( | const PropertySet & | other | ) |

Copies another PropertySet over this one.

References PropertySet().

## getValue()

String juce::PropertySet::getValue | ( | StringRef | keyName,
|  | const String & | defaultReturnValue = String() ) const

noexcept

Returns one of the properties as a string.

If the value isn't found in this set, then this will look for it in a fallback property set (if you've specified one with the setFallbackPropertySet() method), and if it can't find one there, it'll return the default value passed-in.

Parameters

  keyName | the name of the property to retrieve
  defaultReturnValue | a value to return if the named property doesn't actually exist

## getIntValue()

int juce::PropertySet::getIntValue | ( | StringRef | keyName,
|  | int | defaultReturnValue = 0 ) const

noexcept

Returns one of the properties as an integer.

If the value isn't found in this set, then this will look for it in a fallback property set (if you've specified one with the setFallbackPropertySet() method), and if it can't find one there, it'll return the default value passed-in.

Parameters

  keyName | the name of the property to retrieve
  defaultReturnValue | a value to return if the named property doesn't actually exist

References getIntValue().

Referenced by getIntValue().

## getDoubleValue()

double juce::PropertySet::getDoubleValue | ( | StringRef | keyName,
|  | double | defaultReturnValue = 0.0 ) const

noexcept

Returns one of the properties as an double.

If the value isn't found in this set, then this will look for it in a fallback property set (if you've specified one with the setFallbackPropertySet() method), and if it can't find one there, it'll return the default value passed-in.

Parameters

  keyName | the name of the property to retrieve
  defaultReturnValue | a value to return if the named property doesn't actually exist

References getDoubleValue().

Referenced by getDoubleValue().

## getBoolValue()

bool juce::PropertySet::getBoolValue | ( | StringRef | keyName,
|  | bool | defaultReturnValue = false ) const

noexcept

Returns one of the properties as an boolean.

The result will be true if the string found for this key name can be parsed as a non-zero integer.

If the value isn't found in this set, then this will look for it in a fallback property set (if you've specified one with the setFallbackPropertySet() method), and if it can't find one there, it'll return the default value passed-in.

Parameters

  keyName | the name of the property to retrieve
  defaultReturnValue | a value to return if the named property doesn't actually exist

References getBoolValue().

Referenced by getBoolValue().

## getXmlValue()

std::unique_ptr< XmlElement > juce::PropertySet::getXmlValue | ( | StringRef | keyName | ) | const

Returns one of the properties as an XML element.

The result will a new XMLElement object. It may return nullptr if the key isn't found, or if the entry contains an string that isn't valid XML.

If the value isn't found in this set, then this will look for it in a fallback property set (if you've specified one with the setFallbackPropertySet() method), and if it can't find one there, it'll return the default value passed-in.

Parameters

  keyName | the name of the property to retrieve

References getXmlValue().

Referenced by getXmlValue().

## setValue() [1/2]

void juce::PropertySet::setValue | ( | StringRef | keyName,
|  | const var & | value )

Sets a named property.

Parameters

  keyName | the name of the property to set. (This mustn't be an empty string)
  value | the new value to set it to

References setValue().

Referenced by setValue(), and setValue().

## setValue() [2/2]

void juce::PropertySet::setValue | ( | StringRef | keyName,
|  | const XmlElement * | xml )

Sets a named property to an XML element.

Parameters

  keyName | the name of the property to set. (This mustn't be an empty string)
  xml | the new element to set it to. If this is a nullptr, the value will be set to an empty string

See also
  getXmlValue

References setValue().

## addAllPropertiesFrom()

void juce::PropertySet::addAllPropertiesFrom | ( | const PropertySet & | source | ) |

This copies all the values from a source PropertySet to this one.

This won't remove any existing settings, it just adds any that it finds in the source set.

References addAllPropertiesFrom(), and PropertySet().

Referenced by addAllPropertiesFrom().

## removeValue()

void juce::PropertySet::removeValue | ( | StringRef | keyName | ) |

Deletes a property.

Parameters

  keyName | the name of the property to delete. (This mustn't be an empty string)

References removeValue().

Referenced by removeValue().

## containsKey()

bool juce::PropertySet::containsKey | ( | StringRef | keyName | ) | const

noexcept

Returns true if the properties include the given key.

References containsKey().

Referenced by containsKey().

## clear()

void juce::PropertySet::clear | ( |  | ) |

Removes all values.

References clear().

Referenced by clear().

## getAllProperties()

StringPairArray & juce::PropertySet::getAllProperties | ( |  | ) |

inline noexcept

Returns the keys/value pair array containing all the properties.

References getAllProperties().

Referenced by getAllProperties().

## getLock()

const CriticalSection & juce::PropertySet::getLock | ( |  | ) | const

inline noexcept

Returns the lock used when reading or writing to this set.

## createXml()

std::unique_ptr< XmlElement > juce::PropertySet::createXml | ( | const String & | nodeName | ) | const

Returns an XML element which encapsulates all the items in this property set.

The string parameter is the tag name that should be used for the node.

See also
  restoreFromXml

## restoreFromXml()

void juce::PropertySet::restoreFromXml | ( | const XmlElement & | xml | ) |

Reloads a set of properties that were previously stored as XML.

The node passed in must have been created by the createXml() method.

See also
  createXml

## setFallbackPropertySet()

void juce::PropertySet::setFallbackPropertySet | ( | PropertySet * | fallbackProperties | ) |

noexcept

Sets up a second PropertySet that will be used to look up any values that aren't set in this one.

If you set this up to be a pointer to a second property set, then whenever one of the getValue() methods fails to find an entry in this set, it will look up that value in the fallback set, and if it finds it, it will return that.

Make sure that you don't delete the fallback set while it's still being used by another set! To remove the fallback set, just call this method with a null pointer.

See also
  getFallbackPropertySet

References PropertySet().

## getFallbackPropertySet()

PropertySet * juce::PropertySet::getFallbackPropertySet | ( |  | ) | const

inline noexcept

Returns the fallback property set.

See also
  setFallbackPropertySet

References PropertySet().

## propertyChanged()

virtual void juce::PropertySet::propertyChanged | ( |  | ) |

protected virtual

Subclasses can override this to be told when one of the properties has been changed.

Reimplemented in juce::PropertiesFile.

References PropertySet().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited